var chatMediaHandler = {};

/**
 *    Image Upload
 **/
// 写真アップロード
$("#imageInputButton").on("click", function () {
  $("#imageInputTag").click();
});

$("#imageInputTag").on("change", function () {
  $("#image-form").submit();
  // reset the value of form
  $("#imageInputTag").val("");
});

$("#image-form").on("submit", function (e) {
  e.preventDefault();
  const imageInputTag = $("#imageInputTag");
  const file = imageInputTag.prop("files")[0];
  if (file) {
    $(".overlay").addClass("active undismissable");
    $(".loader").addClass("active");
    CHAT_UI.showLoadingIndicator();
    var fd = new FormData($(this)[0]);
    console.log($(this)[0]);
    //画像の大きさが500pixelより大きかったら、thumbnailを生成
    CHAT.createThumbnailAndUpload(
      file,
      function (resizeFile, thumbnailCreated) {
        if (resizeFile && thumbnailCreated) {
          //ただ、画像の大きさが500pixel以下の場合はthumbnailは生成されない
          fd.append("thumb", resizeFile);
        }

        // イメージをアップロード
        CHAT.uploadImage(fd);
      }
    );
  }
});

/**
 *    Video Upload
 **/
// 動画アップロード
$("#videoUploadButton").on("click", function () {
  $("#videoInputTag").click();
});

$("#videoInputTag").on("change", function () {
  $("#video-form").submit();
  // reset the value of form
  $("#videoInputTag").val("");
});

$("#video-form").on("submit", function (e) {
  e.preventDefault();
  const videoInputTag = $("#videoInputTag");
  const file = videoInputTag.prop("files")[0];
  if (file) {
    $(".overlay").addClass("active undismissable");
    $(".loader").addClass("active");
    CHAT_UI.showLoadingIndicator();
    var fd = new FormData($(this)[0]);

    if (!file.type.includes("image")) {
      // video 保存
      // CHAT.createVideoThumbnailAndUpload(file, function(resizeFile, thumbnailCreated) {
      //     if(resizeFile && thumbnailCreated) {
      //         //ただ、画像の大きさが500pixel以下の場合はthumbnailは生成されない
      //         fd.append('thumb', resizeFile)
      //     }
      //     CHAT.uploadImage(fd);
      // })
      CHAT.uploadImage(fd);
      return;
    }
  }
});

// this method call from android only for now
CHAT_UI.videoEncodeFail = function () {
  alert(getLocalizedString("error_send_video"));
  CHAT_UI.dismissLoadingIndicator();
};

// this method call from android only for now
CHAT_UI.videoEncodeEnd = function (encodedUri) {
  var fileName = encodedUri.split("/")[encodedUri.split("/").length - 1];
  var fileURL = "file:" + encodedUri;
  var xhr = new XMLHttpRequest();
  xhr.open("GET", fileURL);
  xhr.responseType = "blob";
  xhr.addEventListener("load", function () {
    var formData = new FormData();
    formData.append("image", xhr.response, fileName);
    formData.append("sid", currentUserInfo.sid);
    formData.append("roomId", roomInfo.roomID);
    jQuery
      .ajax({
        async: true,
        url: serverInfo.cmsURL + "/chatapi/file/upload",
        type: "post",
        data: formData,
        contentType: false,
        processData: false,
        error: function () {
          alert(getLocalizedString("error_send_video"));
          CHAT_UI.dismissLoadingIndicator();
        },
      })
      .done(function (res) {
        if (deviceInfo.isAndroid()) {
          android.removeEncodedVideo(encodedUri);
        }
        var imgPath =
          serverInfo.cmsURL +
          "/chatapi/file/getImage?fileName=" +
          res.fileName +
          "&roomId=" +
          roomInfo.roomID;
        var imageName = res.fileName;

        // uploadFileの判断
        var extension = imageName
          .substr(imageName.lastIndexOf(".") + 1)
          .toLowerCase();

        if (res.thumbnailPath && res.thumbnailPath.length > 0) {
          imgPath =
            serverInfo.cmsURL +
            "/chatapi/file/getImage?fileName=" +
            res.thumbImageFileName +
            "&roomId=" +
            roomInfo.roomID;
        }
        let downloadPath =
          serverInfo.cmsURL +
          "/chatapi/file/download?fileName=" +
          imageName +
          "&roomId=" +
          roomInfo.roomID;
        var videoSrc =
          serverInfo.cmsURL +
          "/chatapi/file/getImage?fileName=" +
          res.fileName +
          "&roomId=" +
          roomInfo.roomID;
        const totalDiv = $("<div/>", { id: "attachedImages" });
        const videoTag = $("<video/>", {
          controls: "true",
          width: "auto",
          style: "max-width:100%",
        });
        const source = $("<source/>", { src: videoSrc });
        const downloadIcon = $("<a/>", {
          href: downloadPath,
          class: "fa fa-download",
          download: res.fileName,
        });
        videoTag.append(source);
        totalDiv.append(videoTag);
        totalDiv.append(downloadIcon);
        let text = totalDiv.prop("outerHTML");
        let encodedText;
        try {
          encodedText = encodeURIComponent(text);
        } catch (e) {
          encodedText = text;
        }
        const sendData = encodedText + messageSeperator + MessageType.VIDEO;
        CHAT_SOCKET.emitCreateMessage(sendData, 1);

        $(".overlay").removeClass("active undismissable");
        $(".loader").removeClass("active");
        CHAT_UI.dismissLoadingIndicator();
      });
  });
  xhr.send();
};
